//
//  NSObject+KMAssociatedObjects.h
//  SMObservation
//
//  Created by Stephan Michels on 01.08.11.
//  Copyright (c) 2012 Stephan Michels Softwareentwicklung und Beratung. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSObject (SMAssociatedObjects)

+ (void)setAssociateValue:(id)value withKey:(void *)key;
+ (id)associatedValueForKey:(void *)key;

- (void)setAssociateValue:(id)value withKey:(void *)key;
- (id)associatedValueForKey:(void *)key;

@end

#define SMAssociatePropertySynthesize(SETTER, GETTER, TYPE) static void * AssocProperty_##GETTER = &AssocProperty_##GETTER; \
\
- (void)SETTER:(TYPE)value {\
	[self setAssociateValue:value withKey:AssocProperty_##GETTER];\
}\
\
- (TYPE)GETTER {\
	return [self associatedValueForKey:AssocProperty_##GETTER];\
}

#define SMAssociateBooleanPropertySynthesize(SETTER, GETTER) static void * AssocProperty_##GETTER = &AssocProperty_##GETTER; \
\
- (void)SETTER:(BOOL)value {\
	[self setAssociateValue:@(value) withKey:AssocProperty_##GETTER];\
}\
\
- (BOOL)GETTER {\
	return [[self associatedValueForKey:AssocProperty_##GETTER] boolValue];\
}
