//
//  NSObject+SMKeyValueBinding.h
//  Drawings
//
//  Created by Stephan Michels on 25.10.11.
//  Copyright 2011 Stephan Michels Software Entwicklung und Betratung. All rights reserved.
//

#import <Cocoa/Cocoa.h>


// original source from http://code.google.com/p/amber-framework/
// and http://tomdalling.com/blog/cocoa/implementing-your-own-cocoa-bindings/

@interface NSObject (SMKeyValueBinding)

/*!
 @brief
 This method will run the value through a value transformer if one is provided.
 It will retrieve an unbound value from the <tt>-infoForBinding:</tt> dictionary under the AFUnboundValueKey if the controller object is nil.
 */
- (id)valueForBinding:(NSString *)binding;

/*!
 @brief
 This method will reverse the value through a value transformer if one is provided.
 It will store the value in the <tt>-infoForBinding:</tt> dictionary under the AFUnboundValueKey if the controller object is nil.
 */
- (void)setValue:(id)value forBinding:(NSString *)binding;

@end
