//
//  SMActionItem.h
//  SMActionBar
//
//  Created by Stephan Michels on 18.02.13.
//  Copyright (c) 2013 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>


typedef NS_ENUM(NSUInteger, SMActionBarType) {
    SMActionBarTypeButton = 0,
	SMActionBarTypeCheckbox,
    SMActionBarTypeSeparator,
};

@interface SMActionBarItem : NSObject <NSValidatedUserInterfaceItem>

@property (nonatomic, assign) SMActionBarType type;
@property (nonatomic, strong) NSImage *image;
@property (nonatomic, strong) NSImage *alternateImage;
@property (nonatomic) NSCellStateValue state;
@property (nonatomic, copy) NSString *label;
@property (nonatomic, assign, getter = isEnabled) BOOL enabled;
@property (nonatomic, assign) BOOL autovalidates;
@property (nonatomic, copy) NSString *toolTip;
@property (nonatomic, copy) NSString *keyEquivalent;
@property (nonatomic) NSUInteger keyEquivalentModifierMask;
@property (nonatomic, strong) NSMenu *menu;
@property (nonatomic, strong) NSView *view;
@property (nonatomic, assign) id target;
@property (nonatomic, assign) SEL action;
@property (nonatomic, assign) NSInteger tag;
@property (nonatomic, assign) NSSize minSize;
@property (nonatomic, assign) NSSize maxSize;
@property (nonatomic, assign) NSEdgeInsets edgeInsets;

@end
