//
//  SMBlockObservation.h
//  SMObservation
//
//  Created by Stephan Michels on 22.11.12.
//  Copyright (c) 2012 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SMCancellable.h"

// original code from https://github.com/rayh/kvo-block-binding
// and from https://gist.github.com/153676
// and https://github.com/schwa/KVO-Notification-Manager

@class SMBlockObservation;

typedef void (^SMObservationBlock)(SMBlockObservation *observation, NSDictionary *change);


@interface SMBlockObservation : NSObject<SMCancellable>

@property (nonatomic, unsafe_unretained, readonly) id object;
@property (nonatomic, copy, readonly) NSString *keyPath;
@property (nonatomic, readonly) NSKeyValueObservingOptions options;

+ (instancetype)observationWithObject:(id)object
                           forKeyPath:(NSString *)keyPath
                              options:(NSKeyValueObservingOptions)options
                           usingBlock:(SMObservationBlock)block;

@end