//
//  SMBlocksTypes.h
//  SMBlocks
//

#import <dispatch/dispatch.h>
#import <Foundation/Foundation.h>


// original source from https://github.com/pandamonia/BlocksKit

typedef void (^SMBlock)(void); // compatible with dispatch_block_t
typedef void (^SMSenderBlock)(id sender);
typedef void (^SMSenderKeyPathBlock)(id object, NSString *keyPath);
typedef void (^SMKeyValueBlock)(id key, id object);
typedef void (^SMIndexBlock)(NSUInteger index);
typedef void (^SMTimerBlock)(NSTimeInterval time);
typedef void (^SMResponseBlock)(NSURLResponse *response);

typedef BOOL (^SMValidationBlock)(id object);
typedef BOOL (^SMKeyValueValidationBlock)(id key, id object);
typedef BOOL (^SMIndexValidationBlock)(NSUInteger index);

typedef id (^SMReturnBlock)(void);
typedef id (^SMTransformBlock)(id object);
typedef id (^SMKeyValueTransformBlock)(id key, id object);
typedef id (^SMAccumulationBlock)(id sum, id object);

typedef NSUInteger (^SMIndexTransformBlock)(NSUInteger index);