//
//  SMInspectorConfiguration.h
//  SMInspectorKit
//
//  Created by Stephan Michels on 10.11.12.
//  Copyright (c) 2012 Stephan Michels. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface SMInspectorConfiguration : NSObject

- (id)initWIthURL:(NSURL *)url error:(NSError **)error;
- (id)init NS_UNAVAILABLE;
+ (id)new NS_UNAVAILABLE;

- (NSString *)name;
- (NSArray *)configurations;
- (NSArray *)configurationsNamed:(NSString *)name;
- (BOOL)hasValueNamed:(NSString *)name;
- (SEL)selectorValueNamed:(NSString *)name
			 defaultValue:(SEL)defaultValue;
- (double)doubleValueNamed:(NSString *)name
			  defaultValue:(double)defaultValue;
- (NSString *)localizedStringValueNamed:(NSString *)name
						   defaultValue:(id)defaultValue;
- (NSString *)stringValueNamed:(NSString *)name
				  defaultValue:(id)defaultValue;
- (NSColor *)colorForValueNamed:(NSString *)name
				   defaultValue:(id)defaultValue;
- (BOOL)booleanValueNamed:(NSString *)name
			 defaultValue:(BOOL)defaultValue;
- (long long)integerValueNamed:(NSString *)name
				  defaultValue:(long long)defaultValue;
- (unsigned long long)unsignedIntegerValueNamed:(NSString *)name
								   defaultValue:(unsigned long long)defaultValue;
- (NSValueTransformer *)valueTransformerForAttributeNamed:(NSString *)name
											 defaultValue:(NSValueTransformer *)defaultValue;
- (NSURL *)urlValueNamed:(NSString *)name
            defaultValue:(NSURL *)defaultValue;

@end
