//
//  SMKeyPathObservation.h
//  Drawings
//
//  Created by Stephan Michels on 15.01.13.
//  Copyright (c) 2013 Stephan Michels Softwareentwicklung und Beratung. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SMCancellable.h"

@class SMKeyPathObservation;

typedef void (^SMKeyPathObservationBlock)(SMKeyPathObservation *observation, NSDictionary *change);


@interface SMKeyPathObservation : NSObject<SMCancellable>

@property (nonatomic, unsafe_unretained, readonly) id object;
@property (nonatomic, copy, readonly) NSString *keyPath;

+ (instancetype)observationWithObject:(id)object
                           forKeyPath:(NSString *)keyPath
                              options:(NSKeyValueObservingOptions)options
                           usingBlock:(SMKeyPathObservationBlock)block;
@end
