//
//  SMMacros.h
//  Drawings
//
//  Created by Stephan Michels on 02.01.13.
//  Copyright (c) 2013 Stephan Michels Softwareentwicklung und Beratung. All rights reserved.
//

#define SMContextDefine(NAME) static void * NAME = &NAME;

#define SMConstantDefine(NAME) NSString * const NAME = @#NAME;
#define SMConstantExtern(NAME) extern NSString * const NAME;

#define SMKeyDefine(NAME) static NSString * NAME = @#NAME;

#define SMWeakify(VAR) __weak __typeof__(VAR) _weak_##VAR = VAR;

#define SMUnsafeify(VAR) __unsafe_unretained __typeof__(VAR) _weak_##VAR = VAR;

#define SMStrongify(VAR) __strong __typeof__(VAR) VAR = _weak_##VAR;

// original source from https://gist.github.com/steipete/5664543
#ifndef NS_REQUIRES_SUPER
	#if __has_attribute(objc_requires_super)
		#define NS_REQUIRES_SUPER __attribute((objc_requires_super))
	#else
		#define NS_REQUIRES_SUPER
	#endif
#endif

// original source from https://gist.github.com/JaviSoto/5906004
#ifndef NS_UNAVAILABLE
	#if __has_attribute(unavailable)
		#define NS_UNAVAILABLE __attribute__((unavailable("Method should not be called")))
	#else
		#define NS_UNAVAILABLE
	#endif
#endif

#ifndef NS_UNAVAILABLE_INIT
	#if __has_attribute(unavailable)
		#define NS_UNAVAILABLE_INIT(__SEL__) __attribute__((unavailable("Invoke the designated initializer '" # __SEL__ "' instead.")))
	#else
		#define NS_UNAVAILABLE_INIT
	#endif
#endif


#ifndef NS_ABSTRACT
	#if __has_attribute(unavailable)
		#define NS_ABSTRACT __attribute__((unavailable("Abstract method should not be invoked.")))
	#else
		#define NS_ABSTRACT
	#endif
#endif