//
//  SMSeparator.h
//  SMTabBar
//
//  Created by Stephan Michels on 12.02.12.
//  Copyright (c) 2012 Stephan Michels Softwareentwicklung und Beratung. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "SMView.h"

typedef NS_ENUM(NSUInteger, SMSeparatorLevel) {
	SMSeparatorLevel1,
	SMSeparatorLevel2,
	SMSeparatorLevel3,
};

@interface NSColor (SMSeparator)

+ (NSColor *)level1ActiveSeparatorColor;
+ (NSColor *)level1InactiveSeparatorColor;

+ (NSColor *)level2ActiveSeparatorColor;
+ (NSColor *)level2InactiveSeparatorColor;

+ (NSColor *)level3ActiveSeparatorColor;
+ (NSColor *)level3InactiveSeparatorColor;

+ (NSColor *)separatorColorForLevel:(SMSeparatorLevel)level active:(BOOL)active;

@end


@interface SMSeparator : SMView

@property (nonatomic) SMSeparatorLevel level;
@property (nonatomic) NSEdgeInsets edgeInsets;

@end
